WORDS_DICT = {'lys_linker': {'LYS': 'CA+CB+CB+CG+CD+CG'}, 'ser_linker': {'SER': 'CA+CB', 'SEP': 'CA+CB'}, 'alanine': {'ALA': 'CA+CB'}, 'guanidinium': {'ARG': 'CD+NE+CZ+NH1+CZ+NE+CZ+NH2'}, 'glu_linker': {'GLU': 'CA+CB+CB+CG+CD+CG'}, 'valine': {'VAL': 'CB+CG2+CA+CB+CB+CG1'}, 'lys_end': {'LYS': 'CD+CE+CE+NZ'}, 'isoleucine': {'ILE': 'CD1+CG1+CB+CG1+CB+CG2+CA+CB'}, 'thr_linker': {'TPO': 'CB+CG2+CA+CB', 'THR': 'CA+CB+CB+CG2'}, 'indole': {'TRP': 'CD1+CG+CD1+NE1+CD2+CG+CE2+NE1+CD2+CE3+CD2+CE2+CE3+CZ3+CE2+CZ2+CH2+CZ3+CH2+CZ2'}, 'asn_linker': {'ASN': 'CB+CG+CA+CB'}, 'trp_linker': {'TRP': 'CA+CB+CB+CG'}, 'arg_linker': {'ARG': 'CD+CG+CB+CG+CA+CB'}, 'leucine': {'LEU': 'CA+CB+CB+CG+CD2+CG+CD1+CG'}, 'proline': {'PRO': 'CD+CG+CB+CG'}, 'imidazole': {'HIP': 'CE1+ND1+CG+ND1+CE1+NE2+CD2+CG+CD2+NE2', 'HIS': 'CD2+NE2+CE1+NE2+CD2+CG+CE1+ND1+CG+ND1'}, 'carboxyl': {'ASP': 'CG+OD2+CG+OD1', 'GLU': 'CD+OE2+CD+OE1', 'PHD': 'CG+OD1+CG+OD2'}, 'phenyl': {'PTR': 'CD1+CG+CD1+CE1+CD2+CG+CE1+CZ+CD2+CE2+CE2+CZ', 'TYR': 'CE1+CZ+CD1+CE1+CE2+CZ+CD1+CG+CD2+CE2+CD2+CG', 'PHE': 'CD2+CE2+CD2+CG+CE2+CZ+CD1+CG+CE1+CZ+CD1+CE1'}, 'asp_linker': {'ASP': 'CB+CG+CA+CB', 'PHD': 'CA+CB+CB+CG'}, 'hydroxyl': {'SER': 'CB+OG', 'TYR': 'CZ+OH', 'THR': 'CB+OG1'}, 'gln_linker': {'GLN': 'CA+CB+CB+CG+CD+CG'}, 'tyr_linker': {'PTR': 'CA+CB+CB+CG', 'TYR': 'CA+CB+CB+CG'}, 'peptide_bond': {'ILE': 'CA+N+C+CA+C+O', 'ASN': 'CA+N+C+CA+C+O', 'GLN': 'CA+N+C+CA+C+O', 'GLY': 'CA+N+C+CA+C+O', 'ALA': 'CA+N+C+CA+C+O', 'GLU': 'CA+N+C+CA+C+O', 'HIP': 'CA+N+C+CA+C+O', 'HIS': 'CA+N+C+CA+C+O', 'SER': 'CA+N+C+CA+C+O', 'SEP': 'C+O+C+CA+CA+N', 'PRO': 'CA+N+C+CA+C+O', 'PTR': 'CA+N+C+CA+C+O', 'CYS': 'CA+N+C+CA+C+O', 'VAL': 'CA+N+C+CA+C+O', 'TPO': 'CA+N+C+CA+C+O', 'THR': 'CA+N+C+CA+C+O', 'ASP': 'CA+N+C+CA+C+O', 'TRP': 'CA+N+C+CA+C+O', 'LYS': 'CA+N+C+CA+C+O', 'PHE': 'CA+N+C+CA+C+O', 'PHD': 'CA+N+C+CA+C+O', 'MET': 'CA+N+C+CA+C+O', 'LEU': 'CA+N+C+CA+C+O', 'ARG': 'CA+N+C+CA+C+O', 'TYR': 'CA+N+C+CA+C+O'}, 'carboxamide': {'ASN': 'CG+ND2+CG+OD1', 'GLN': 'CD+NE2+CD+OE1'}, 'phe_linker': {'PHE': 'CA+CB+CB+CG'}, 'phosphate': {'HIP': 'O2P+P+O3P+P+O1P+P+ND1+P', 'TPO': 'O1P+P+O2P+P+O3P+P+OG1+P', 'SEP': 'O3P+P+O2P+P+OG+P+O1P+P', 'PTR': 'OH+P+O1P+P+O2P+P+O3P+P', 'PHD': 'OD1+P+OP3+P+OP1+P+OP2+P'}, 'cysteine': {'CYS': 'CA+CB+CB+SG'}, 'met_linker': {'MET': 'CA+CB+CB+CG'}, 'his_linker': {'HIP': 'CB+CG+CA+CB', 'HIS': 'CB+CG+CA+CB'}, 'met_end': {'MET': 'CE+SD+CG+SD'}}

BOND_WORD_DICT = {('PRO', 'CB', 'CG'): 'proline', ('ILE', 'C', 'O'): 'peptide_bond', ('TRP', 'CE2', 'NE1'): 'indole', ('ARG', 'CZ', 'NH1'): 'guanidinium', ('SEP', 'C', 'O'): 'peptide_bond', ('LYS', 'C', 'CA'): 'peptide_bond', ('TPO', 'O2P', 'P'): 'phosphate', ('TPO', 'C', 'O'): 'peptide_bond', ('ARG', 'CZ', 'NE'): 'guanidinium', ('ARG', 'C', 'CA'): 'peptide_bond', ('HIP', 'CE1', 'NE2'): 'imidazole', ('TYR', 'CA', 'N'): 'peptide_bond', ('TYR', 'CD2', 'CG'): 'phenyl', ('VAL', 'C', 'CA'): 'peptide_bond', ('PHD', 'CG', 'OD2'): 'carboxyl', ('TRP', 'CA', 'N'): 'peptide_bond', ('PHD', 'C', 'CA'): 'peptide_bond', ('SEP', 'O2P', 'P'): 'phosphate', ('PTR', 'CD2', 'CE2'): 'phenyl', ('GLY', 'C', 'CA'): 'peptide_bond', ('GLU', 'CD', 'CG'): 'glu_linker', ('TRP', 'CD1', 'NE1'): 'indole', ('TRP', 'CD2', 'CE2'): 'indole', ('ASP', 'C', 'CA'): 'peptide_bond', ('ILE', 'CB', 'CG1'): 'isoleucine', ('ASN', 'C', 'CA'): 'peptide_bond', ('MET', 'CB', 'CG'): 'met_linker', ('HIP', 'O2P', 'P'): 'phosphate', ('PHE', 'CE1', 'CZ'): 'phenyl', ('PRO', 'C', 'CA'): 'peptide_bond', ('PHE', 'CE2', 'CZ'): 'phenyl', ('TYR', 'CA', 'CB'): 'tyr_linker', ('ASN', 'CG', 'ND2'): 'carboxamide', ('PHE', 'C', 'O'): 'peptide_bond', ('GLN', 'CD', 'NE2'): 'carboxamide', ('LYS', 'CA', 'N'): 'peptide_bond', ('HIS', 'CG', 'ND1'): 'imidazole', ('PHE', 'CD1', 'CE1'): 'phenyl', ('MET', 'CA', 'N'): 'peptide_bond', ('SEP', 'OG', 'P'): 'phosphate', ('ALA', 'CA', 'N'): 'peptide_bond', ('CYS', 'CA', 'N'): 'peptide_bond', ('THR', 'CB', 'OG1'): 'hydroxyl', ('ASP', 'CG', 'OD1'): 'carboxyl', ('HIP', 'CD2', 'NE2'): 'imidazole', ('LYS', 'CA', 'CB'): 'lys_linker', ('MET', 'C', 'O'): 'peptide_bond', ('TRP', 'CD2', 'CG'): 'indole', ('HIS', 'CB', 'CG'): 'his_linker', ('MET', 'CG', 'SD'): 'met_end', ('ARG', 'C', 'O'): 'peptide_bond', ('HIP', 'CE1', 'ND1'): 'imidazole', ('TPO', 'OG1', 'P'): 'phosphate', ('TRP', 'CA', 'CB'): 'trp_linker', ('ARG', 'CB', 'CG'): 'arg_linker', ('PTR', 'O3P', 'P'): 'phosphate', ('LEU', 'CD1', 'CG'): 'leucine', ('SEP', 'O3P', 'P'): 'phosphate', ('MET', 'CA', 'CB'): 'met_linker', ('TYR', 'CD1', 'CE1'): 'phenyl', ('ALA', 'CA', 'CB'): 'alanine', ('GLU', 'CD', 'OE1'): 'carboxyl', ('PHE', 'CD1', 'CG'): 'phenyl', ('PHD', 'C', 'O'): 'peptide_bond', ('THR', 'CA', 'N'): 'peptide_bond', ('GLY', 'CA', 'N'): 'peptide_bond', ('TYR', 'CZ', 'OH'): 'hydroxyl', ('ASP', 'CA', 'CB'): 'asp_linker', ('THR', 'CA', 'CB'): 'thr_linker', ('SEP', 'C', 'CA'): 'peptide_bond', ('LEU', 'C', 'CA'): 'peptide_bond', ('PHD', 'CB', 'CG'): 'asp_linker', ('SER', 'C', 'CA'): 'peptide_bond', ('ASP', 'CA', 'N'): 'peptide_bond', ('TPO', 'CB', 'CG2'): 'thr_linker', ('CYS', 'C', 'O'): 'peptide_bond', ('TRP', 'CH2', 'CZ2'): 'indole', ('ILE', 'CA', 'CB'): 'isoleucine', ('PTR', 'C', 'CA'): 'peptide_bond', ('LYS', 'CD', 'CG'): 'lys_linker', ('PRO', 'CD', 'CG'): 'proline', ('GLU', 'C', 'O'): 'peptide_bond', ('TRP', 'CH2', 'CZ3'): 'indole', ('TPO', 'O1P', 'P'): 'phosphate', ('ILE', 'CA', 'N'): 'peptide_bond', ('HIP', 'C', 'CA'): 'peptide_bond', ('LYS', 'CD', 'CE'): 'lys_end', ('PTR', 'O1P', 'P'): 'phosphate', ('HIP', 'CA', 'CB'): 'his_linker', ('MET', 'C', 'CA'): 'peptide_bond', ('VAL', 'CA', 'N'): 'peptide_bond', ('SEP', 'CA', 'CB'): 'ser_linker', ('THR', 'CB', 'CG2'): 'thr_linker', ('LEU', 'CA', 'CB'): 'leucine', ('ASP', 'C', 'O'): 'peptide_bond', ('LEU', 'CB', 'CG'): 'leucine', ('PTR', 'CD1', 'CE1'): 'phenyl', ('PRO', 'C', 'O'): 'peptide_bond', ('HIS', 'CD2', 'NE2'): 'imidazole', ('HIP', 'ND1', 'P'): 'phosphate', ('PHE', 'C', 'CA'): 'peptide_bond', ('ARG', 'CZ', 'NH2'): 'guanidinium', ('HIP', 'CD2', 'CG'): 'imidazole', ('PTR', 'OH', 'P'): 'phosphate', ('TYR', 'CE1', 'CZ'): 'phenyl', ('PTR', 'CB', 'CG'): 'tyr_linker', ('TYR', 'CE2', 'CZ'): 'phenyl', ('VAL', 'CB', 'CG2'): 'valine', ('LEU', 'C', 'O'): 'peptide_bond', ('CYS', 'C', 'CA'): 'peptide_bond', ('VAL', 'CA', 'CB'): 'valine', ('LEU', 'CA', 'N'): 'peptide_bond', ('GLU', 'CA', 'N'): 'peptide_bond', ('LYS', 'C', 'O'): 'peptide_bond', ('GLY', 'C', 'O'): 'peptide_bond', ('SER', 'C', 'O'): 'peptide_bond', ('PTR', 'O2P', 'P'): 'phosphate', ('GLU', 'CA', 'CB'): 'glu_linker', ('GLU', 'CB', 'CG'): 'glu_linker', ('GLN', 'CA', 'N'): 'peptide_bond', ('PHE', 'CD2', 'CG'): 'phenyl', ('TYR', 'C', 'CA'): 'peptide_bond', ('HIS', 'CA', 'CB'): 'his_linker', ('PHD', 'CG', 'OD1'): 'carboxyl', ('PHE', 'CA', 'N'): 'peptide_bond', ('ASN', 'CG', 'OD1'): 'carboxamide', ('PTR', 'C', 'O'): 'peptide_bond', ('HIS', 'CA', 'N'): 'peptide_bond', ('ILE', 'CB', 'CG2'): 'isoleucine', ('PHD', 'OD1', 'P'): 'phosphate', ('TRP', 'CD2', 'CE3'): 'indole', ('PHD', 'OP1', 'P'): 'phosphate', ('ALA', 'C', 'CA'): 'peptide_bond', ('LEU', 'CD2', 'CG'): 'leucine', ('TRP', 'C', 'CA'): 'peptide_bond', ('GLN', 'CA', 'CB'): 'gln_linker', ('SEP', 'CA', 'N'): 'peptide_bond', ('GLN', 'CB', 'CG'): 'gln_linker', ('HIP', 'O3P', 'P'): 'phosphate', ('HIP', 'CG', 'ND1'): 'imidazole', ('THR', 'C', 'O'): 'peptide_bond', ('PTR', 'CE1', 'CZ'): 'phenyl', ('HIS', 'C', 'O'): 'peptide_bond', ('TRP', 'CD1', 'CG'): 'indole', ('PHD', 'CA', 'N'): 'peptide_bond', ('ILE', 'C', 'CA'): 'peptide_bond', ('GLU', 'C', 'CA'): 'peptide_bond', ('GLN', 'C', 'CA'): 'peptide_bond', ('PTR', 'CA', 'N'): 'peptide_bond', ('PTR', 'CD1', 'CG'): 'phenyl', ('PHD', 'OP3', 'P'): 'phosphate', ('HIP', 'C', 'O'): 'peptide_bond', ('SER', 'CB', 'OG'): 'hydroxyl', ('HIS', 'CE1', 'NE2'): 'imidazole', ('SEP', 'O1P', 'P'): 'phosphate', ('HIP', 'O1P', 'P'): 'phosphate', ('ASP', 'CG', 'OD2'): 'carboxyl', ('PTR', 'CA', 'CB'): 'tyr_linker', ('TPO', 'C', 'CA'): 'peptide_bond', ('ASN', 'CB', 'CG'): 'asn_linker', ('LYS', 'CE', 'NZ'): 'lys_end', ('CYS', 'CB', 'SG'): 'cysteine', ('VAL', 'CB', 'CG1'): 'valine', ('TYR', 'C', 'O'): 'peptide_bond', ('VAL', 'C', 'O'): 'peptide_bond', ('PHD', 'CA', 'CB'): 'asp_linker', ('ARG', 'CD', 'NE'): 'guanidinium', ('ALA', 'C', 'O'): 'peptide_bond', ('LYS', 'CB', 'CG'): 'lys_linker', ('GLU', 'CD', 'OE2'): 'carboxyl', ('TPO', 'O3P', 'P'): 'phosphate', ('PHE', 'CA', 'CB'): 'phe_linker', ('PHD', 'OP2', 'P'): 'phosphate', ('HIS', 'CD2', 'CG'): 'imidazole', ('PHE', 'CD2', 'CE2'): 'phenyl', ('PRO', 'CA', 'N'): 'peptide_bond', ('ASN', 'C', 'O'): 'peptide_bond', ('TPO', 'CA', 'CB'): 'thr_linker', ('ARG', 'CD', 'CG'): 'arg_linker', ('ARG', 'CA', 'N'): 'peptide_bond', ('TRP', 'CB', 'CG'): 'trp_linker', ('PHE', 'CB', 'CG'): 'phe_linker', ('HIS', 'C', 'CA'): 'peptide_bond', ('MET', 'CE', 'SD'): 'met_end', ('GLN', 'C', 'O'): 'peptide_bond', ('HIS', 'CE1', 'ND1'): 'imidazole', ('TYR', 'CD2', 'CE2'): 'phenyl', ('HIP', 'CA', 'N'): 'peptide_bond', ('TRP', 'CE3', 'CZ3'): 'indole', ('TPO', 'CA', 'N'): 'peptide_bond', ('ILE', 'CD1', 'CG1'): 'isoleucine', ('TRP', 'C', 'O'): 'peptide_bond', ('SER', 'CA', 'N'): 'peptide_bond', ('TYR', 'CD1', 'CG'): 'phenyl', ('TYR', 'CB', 'CG'): 'tyr_linker', ('GLN', 'CD', 'CG'): 'gln_linker', ('ARG', 'CA', 'CB'): 'arg_linker', ('CYS', 'CA', 'CB'): 'cysteine', ('PTR', 'CD2', 'CG'): 'phenyl', ('ASN', 'CA', 'N'): 'peptide_bond', ('SER', 'CA', 'CB'): 'ser_linker', ('HIP', 'CB', 'CG'): 'his_linker', ('GLN', 'CD', 'OE1'): 'carboxamide', ('PTR', 'CE2', 'CZ'): 'phenyl', ('THR', 'C', 'CA'): 'peptide_bond', ('ASN', 'CA', 'CB'): 'asn_linker', ('TRP', 'CE2', 'CZ2'): 'indole', ('ASP', 'CB', 'CG'): 'asp_linker'}

ATOMS_DICT = {('MG', 'MG'): 'mg', ('HOH', 'O'): 'water'}

def get_key(obj, atom, word):
    key = (obj, atom['model'], atom['segi'], atom['chain'], atom['resn'], atom['resi'], word)
    
    return key
    
def get_selection_statement(atom, key, atomNames):
    selectionStatement = None
    if(atom['segi'].strip() == ''):
        selectionStatement = '(object %s and model %s and chain %s and resn %s and resi %s and name %s )' % tuple(list(key[0:2]) + list(key[3:6]) + [atomNames])
    else:
        selectionStatement = '(object %s and model %s and segi %s and chain %s and resn %s and resi %s and name %s )' % tuple(list(key[0:6]) + [atomNames])
        
    return selectionStatement

def find_aa_word(obj, bondAtoms):
    (key, selectionStatement) = (None, None)
    
    # The bond key is of the form (resn, atom0, atom1) where the atom
    # names are in alphabetical order.
    atomNames = [bondAtoms[0]['name'], bondAtoms[1]['name']]
    atomNames.sort()
    bond_key = (bondAtoms[0]['resn'], atomNames[0], atomNames[1])
    
    if(bond_key in BOND_WORD_DICT):
        word = BOND_WORD_DICT[bond_key]
        # Now form a new key that has the current residue and the word.
        key = get_key(obj, bondAtoms[0], word)
        selectionStatement = get_selection_statement(bondAtoms[0], key, WORDS_DICT[word][key[4]])
            
    return (key, selectionStatement)

def find_suns_atom(obj, selectedAtom):
    (key, selectionStatement) = (None, None)

    atom_key = (selectedAtom['resn'], selectedAtom['name'])
    if(atom_key in ATOMS_DICT):
        key = get_key(obj, selectedAtom, ATOMS_DICT[atom_key])
        selectionStatement = get_selection_statement(selectedAtom, key, atom_key[1])
    
    return (key, selectionStatement)

def __init_plugin__(self):
    pass
